#!/bin/bash
# для отладки set -x

function stringContains() {
    if [[ $2 == *"$1"* ]]; then
      return 0
    else
        return 1
    fi
}

function isDebianBased() {
    local status_info=$(hostnamectl 2>/dev/null | grep -wi "operating system:")
    local _lc=${status_info,,}
    if stringContains "debian" "$_lc" || stringContains "ubuntu" "$_lc" ; then
        return 0
    else
        return 1
    fi
}

function isPackageInstalled() {
    local status_info=$(dpkg -s "$1" 2>/dev/null | grep -wi "status:")
    local _lc=${status_info,,}
    if stringContains "status: install ok" "$_lc" ; then
        return 0
    else
        return 1
    fi
}

function doJaCartaEgaisUtm() {
    local returnStatus=0

    jacartaegaisutm_pkg="jacartaegaisutm"
    jacartaegaisutm_version=""

    jacartaegaisutm_version=$(dpkg -s "$jacartaegaisutm_pkg" | grep "^\s*Version:" | sed "s/^\s*Version:\s*//g")

    echo в системе установлен пакет JaCarta ЕГАИС УТМ "$jacartaegaisutm_pkg" версии "$jacartaegaisutm_version"

    jacartaegaisutm_fpkg=$(ls -1 ${base_dir}/JaCartaEgaisUtm*.deb 2>/dev/null | sed "1!d")
    jacartaegaisutm_finstall=false
    jacartaegaisutm_fversion=""
    jacartaegaisutm_fupgrade=false
    if [ ! -z "$jacartaegaisutm_fpkg" ] ; then
        jacartaegaisutm_fversion=$(dpkg -I "$jacartaegaisutm_fpkg" | grep "^\s*Version:" | sed "s/^\s*Version:\s*//g")
        dpkg --compare-versions "$jacartaegaisutm_fversion" gt "$jacartaegaisutm_version"
        if [ "$?" -eq 0 ] ;then
            local intent
            read -p "имеется инсталляционный пакет JaCarta ЕГАИС УТМ "$jacartaegaisutm_fpkg" версии "$jacartaegaisutm_fversion" выше установленного "$jacartaegaisutm_version", делать апгрейд: (Y|N)?" intent
            if grep -iq "^y" <<< "$intent" ; then
                jacartaegaisutm_fupgrade=true
            fi
        else
            echo имеющийся инсталляционный пакет JaCarta ЕГАИС УТМ "$jacartaegaisutm_fpkg" версии "$jacartaegaisutm_fversion" не выше установленного "$jacartaegaisutm_version"
        fi
    else
        echo инсталляционный пакет JaCarta ЕГАИС УТМ для обновления отсутствует
    fi

    if [ "$jacartaegaisutm_fupgrade" = true ] ; then 
        echo выполняется апгрейд JaCarta ЕГАИС УТМ до версии "$jacartaegaisutm_fversion"
        dpkg --install "$jacartaegaisutm_fpkg" 
        if [ "$?" -eq 0 ] ;then
            echo апгрейд JaCarta ЕГАИС УТМ "$jacartaegaisutm_fpkg" установлен успешно
            echo
            echo Настройка конфигурационных файлов УТМ завершена успешно
            echo "Для того, чтобы изменения вступили в силу, перезапустите УТМ (универсальный транспортный модуль)"
        else
            echo апгрейд JaCarta ЕГАИС УТМ "$jacartaegaisutm_fpkg" НЕ удалось установить
            echo
            echo Настройка конфигурационных файлов УТМ НЕ сделана
            returnStatus=1
        fi
    else
        local intent
        read -p "деинсталлировать JaCarta ЕГАИС УТМ "$jacartaegaisutm_pkg" версии "$jacartaegaisutm_version": (Y|N)?" intent
        if grep -iq "^y" <<< "$intent" ; then
            echo выполняется деинсталляция JaCarta ЕГАИС УТМ версии "$jacartaegaisutm_version"
            dpkg --purge "$jacartaegaisutm_pkg" 
            if [ "$?" -eq 0 ] ;then
                echo JaCarta ЕГАИС УТМ деинсталлирован успешно
                echo
                echo Настройка конфигурационных файлов УТМ завершена успешно
                echo "Для того, чтобы изменения вступили в силу, перезапустите УТМ (универсальный транспортный модуль)"
            else
                echo JaCarta ЕГАИС УТМ деинсталлировать НЕ удалось
                echo
                echo Настройка конфигурационных файлов УТМ НЕ сделана
                returnStatus=1
            fi
        fi
    fi
    
    return $returnStatus
}

function doNoJaCartaEgaisUtm() {
    local returnStatus=0

    utrans_pkg="u-trans:i386"
    utrans_installed=false
    utrans_version=""
    utrans_minimalversion="3.0" # для отладки "1.1.18-1269"
    utrans_version_satisfied=false
    if isPackageInstalled "$utrans_pkg" ; then 
        utrans_installed=true
        utrans_version=$(dpkg -s "$utrans_pkg" | grep "^\s*Version:" | sed "s/^\s*Version:\s*//g")
        dpkg --compare-versions "$utrans_version" ge "$utrans_minimalversion"
        if [ "$?" -eq 0 ] ;then
            utrans_version_satisfied=true
        fi
    fi

    if [ "$utrans_installed" = true ] ; then 
        if [ "$utrans_version_satisfied" = true ] ; then 
            echo установленный в системе пакет ЕГАИС УТМ "$utrans_pkg" версии $utrans_version удовлетворяет условиям
        else
            echo установленный в системе пакет ЕГАИС УТМ "$utrans_pkg" версии $utrans_version НЕ удовлетворяет условиям
            echo требуется версия не ниже $utrans_minimalversion
            returnStatus=1
        fi
    else
        echo в системе не установлен пакет ЕГАИС УТМ "$utrans_pkg" версии не ниже $utrans_minimalversion
        returnStatus=1
    fi

    if [[ "$returnStatus" -ne 0 ]]; then
        local intent
        read -p "Установка \"Модуля поддержки устройств JaCarta для УТМ\" прервана по причине: не обнаружен установленный УТМ удовлетворяющий условиям. Установите УТМ, после чего установите \"Модуль поддержки устройств JaCarta для УТМ\" заново. Для выхода нажмите любую клавишу." intent
        return $returnStatus
    fi
    
    if [[ "$returnStatus" -eq 0 ]]; then
        jaCartaEgaisUtm_pkg="JaCartaEgaisUtm"
        jaCartaEgaisUtm_fpkg=$(ls -1 ${base_dir}/JaCartaEgaisUtm*.deb 2>/dev/null | sed "1!d")

        if [ ! -z "$jaCartaEgaisUtm_fpkg" ] ; then
            local intent
            read -p "имеется пакет JaCarta ЕГАИС УТМ "$jaCartaEgaisUtm_fpkg", устанавливать: (Y|N)?" intent
            if grep -iq "^y" <<< "$intent" ; then
                echo выполняется установка JaCarta ЕГАИС УТМ
                dpkg --install "$jaCartaEgaisUtm_fpkg" 
                if [ "$?" -eq 0 ] ;then
                    echo JaCarta ЕГАИС УТМ установлен успешно
                else
                    echo JaCarta ЕГАИС УТМ НЕ удалось установить
                    returnStatus=1
                fi
            else
                returnStatus=1
            fi
        else
            echo "отсутствует инсталляционный пакет JaCarta ЕГАИС УТМ"
            returnStatus=1
        fi
    fi

    if [[ "$returnStatus" -eq 0 ]]; then
        echo Настройка конфигурационных файлов УТМ завершена успешно
        echo "Для того, чтобы изменения вступили в силу, перезапустите УТМ (универсальный транспортный модуль)"
    else
        echo Настройка конфигурационных файлов УТМ НЕ сделана
    fi
    
    return $returnStatus
}

function doDebian() {
    if ! isPackageInstalled JaCartaEgaisUtm ; then 
        doNoJaCartaEgaisUtm
    else
        doJaCartaEgaisUtm
    fi
}

function doNoDebian() {
    local returnStatus=0
    utrans_pkg="u-trans"
    utrans_minimalversion="3.0"
    jacartaegaisutm_pkg="jacartaegaisutm"

    yum info $utrans_pkg 2>/dev/null
    if [ "$?" -ne 0 ] ;then
        if [ ! -d /opt/utm ]; then
            echo В системе не установлен пакет ЕГАИС УТМ "$utrans_pkg" # версии не ниже $utrans_minimalversion
            echo
            returnStatus=1
            return $returnStatus
        fi
    fi

    yum info $jacartaegaisutm_pkg 2>/dev/null
    if [ "$?" -ne 0 ] ;then

        jacartaegaisutm_fpkg=$(ls -1 ${base_dir}/JaCartaEgaisUtm*.rpm 2>/dev/null | sed "1!d")

        if [ ! -z "$jacartaegaisutm_fpkg" ] ; then
            read -p "имеется пакет JaCarta ЕГАИС УТМ "$jaCartaEgaisUtm_fpkg", устанавливать: (Y|N)?" intent
            if grep -iq "^y" <<< "$intent" ; then
                echo выполняется установка JaCarta ЕГАИС УТМ
                yum -yt install "$jacartaegaisutm_fpkg" 2>/dev/null
                if [ "$?" -eq 0 ] ;then
                    echo JaCarta ЕГАИС УТМ "$jacartaegaisutm_fpkg" установлен успешно
                    echo
                    echo Настройка конфигурационных файлов УТМ завершена успешно
                    echo "Для того, чтобы изменения вступили в силу, перезапустите УТМ (универсальный транспортный модуль)"
                else
                    echo JaCarta ЕГАИС УТМ "$jacartaegaisutm_fpkg" НЕ удалось установить
                    echo
                    echo Настройка конфигурационных файлов УТМ НЕ сделана
                    returnStatus=1
                fi
            else
                returnStatus=1
            fi
        else
            echo инсталляционный пакет JaCarta ЕГАИС УТМ отсутствует
        fi
    else
        local intent
        read -p "деинсталлировать JaCarta ЕГАИС УТМ "$jacartaegaisutm_pkg": (Y|N)?" intent
        if grep -iq "^y" <<< "$intent" ; then
            echo выполняется деинсталляция JaCarta ЕГАИС УТМ 
            yum -yt erase "$jacartaegaisutm_pkg" 2>/dev/null
            if [ "$?" -eq 0 ] ;then
                echo JaCarta ЕГАИС УТМ деинсталлирован успешно
                echo
                echo Настройка конфигурационных файлов УТМ завершена успешно
                echo "Для того, чтобы изменения вступили в силу, перезапустите УТМ (универсальный транспортный модуль)"
            else
                echo JaCarta ЕГАИС УТМ деинсталлировать НЕ удалось
                echo
                echo Настройка конфигурационных файлов УТМ НЕ сделана
                returnStatus=1
            fi
        fi
    fi

    return $returnStatus
}

base_dir=$( dirname "${BASH_SOURCE[0]}" )

if ! isDebianBased ; then 
    doNoDebian
else
    doDebian
fi
